// WARNING! All changes made in this file will be lost!
// Created from 'layers.style' by 'codegen_style'
//
// This file is part of Desktop App Toolkit,
// a set of libraries for developing nice desktop applications.
//
// For license and copyright information please follow this link:
// https://github.com/desktop-app/legal/blob/master/LEGAL
//
#pragma once

#include "ui/style/style_core.h"

#include "styles/style_widgets.h"

namespace style {
namespace internal {

void init_style_layers(int scale);

} // namespace internal

struct RoundButton;
struct TextStyle;
struct Checkbox;
struct Shadow;
struct FlatLabel;
struct ScrollArea;
struct IconButton;
struct LinkButton;
struct InfiniteRadialAnimation;

struct ServiceCheck {
	style::margins margin;
	int diameter;
	int shift;
	int thickness;
	style::point tip;
	int small;
	int large;
	int stroke;
	style::color color;
	int duration;
};

struct Box {
	style::margins buttonPadding;
	int buttonHeight;
	style::RoundButton button;
	style::margins margin;
	style::FlatLabel title;
	style::color bg;
	style::color titleAdditionalFg;
	bool shadowIgnoreTopSkip;
};

} // namespace style

namespace st {
constexpr int boxDuration = 200;
extern const int &boxRadius;
extern const style::font &boxButtonFont;
extern const style::RoundButton &defaultBoxButton;
extern const style::TextStyle &boxLabelStyle;
extern const style::RoundButton &attentionBoxButton;
extern const style::Checkbox &defaultBoxCheckbox;
extern const style::Shadow &boxRoundShadow;
extern const style::font &boxTitleFont;
extern const style::FlatLabel &boxTitle;
extern const style::point &boxTitlePosition;
extern const int &boxTitleHeight;
extern const int &boxTitleAdditionalSkip;
extern const style::font &boxTitleAdditionalFont;
extern const style::ScrollArea &boxScroll;
extern const style::margins &boxRowPadding;
extern const int &boxTopMargin;
extern const style::icon &boxTitleCloseIcon;
extern const style::icon &boxTitleCloseIconOver;
extern const style::IconButton &boxTitleClose;
extern const style::LinkButton &boxLinkButton;
extern const style::margins &boxOptionListPadding;
extern const int &boxOptionListSkip;
extern const int &boxWidth;
extern const int &boxWideWidth;
extern const style::margins &boxPadding;
extern const int &boxMaxListHeight;
extern const int &boxLittleSkip;
extern const int &boxMediumSkip;
extern const style::Box &defaultBox;
extern const style::Box &layerBox;
extern const style::FlatLabel &boxLabel;
extern const style::FlatLabel &boxDividerLabel;
extern const style::margins &defaultBoxDividerLabelPadding;
extern const style::InfiniteRadialAnimation &boxLoadingAnimation;
extern const int &boxLoadingSize;
extern const style::icon &boxDividerTop;
extern const style::icon &boxDividerBottom;
extern const int &boxDividerHeight;
extern const style::FlatLabel &defaultSubsectionTitle;
extern const style::margins &defaultSubsectionTitlePadding;
extern const int &separatePanelBorderCacheSize;
extern const int &separatePanelTitleHeight;
extern const int &separatePanelNoTitleHeight;
extern const style::IconButton &separatePanelClose;
extern const style::IconButton &separatePanelMenu;
extern const style::point &separatePanelMenuPosition;
extern const style::font &separatePanelTitleFont;
extern const style::FlatLabel &separatePanelTitle;
extern const int &separatePanelTitleTop;
extern const int &separatePanelTitleLeft;
extern const int &separatePanelTitleSkip;
extern const style::IconButton &separatePanelBack;
constexpr int separatePanelDuration = 150;
extern const style::RoundButton &webviewDialogButton;
extern const style::RoundButton &webviewDialogDestructiveButton;
extern const style::RoundButton &webviewDialogSubmit;
extern const style::margins &webviewDialogPadding;
} // namespace st
